
package de.ivu.elect.presentation.benutzerverwaltung;

import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;

import de.ivu.elect.business.benutzerverwaltung.boundary.NachrichtConversationStore;
import de.ivu.elect.business.benutzerverwaltung.boundary.NachrichtExtendedDAO;
import de.ivu.elect.business.benutzerverwaltung.boundary.NachrichtEdit;
import de.ivu.elect.business.benutzerverwaltung.entity.Nachricht;
import de.ivu.elect.business.benutzerverwaltung.entity.NachrichtMeta;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.security.UseCaseSecure;
import de.ivu.elect.presentation.View;
import de.ivu.elect.jee.presentation.redirect.Redirect;

@Named(AbstractNachrichtEditNoScopeView.COMPONENT_NAME)
@View(viewId = AbstractNachrichtEditNoScopeView.VIEW_ID, useCase = UseCasePermission.NACHRICHT_EDIT)
public abstract class AbstractNachrichtEditNoScopeView extends de.ivu.elect.presentation.AbstractElectEditView<Nachricht>  {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "nachrichtEditView";

  public static final String VIEW_ID = "/benutzerverwaltung/nachricht-edit.xhtml";

  public static final String PARENT_VIEW_ID = "/benutzerverwaltung/nachricht-search.xhtml";

  @Inject
  protected transient NachrichtExtendedDAO extendedDAO;

  @Inject
  protected transient NachrichtEdit edit;

  @Inject
  @ConversationGroup(NachrichtConversationStore.class)
  protected transient NachrichtConversationStore conversationStore;

  @Inject
  protected transient NachrichtMeta entityMeta;

  @Inject
  // ELECTDD-204 Auf doppelte Bearbeitung von Entitäten Hinweisen
  protected transient NachrichtEditViewScopeStore entityViewStore;

  @de.ivu.elect.jee.faces.PreConditionCheck
  public String checkPreCondition() {
    if (getEntity() == null) {
      return getParentViewId();
    }
    return null;
  }

  @Override
  public Nachricht getEntity() {
    if (conversationStore.getEntityPK() != null) {
      return extendedDAO.findByPrimaryKey(conversationStore.getEntityPK());
    }
    return null;
  }

  public void setEntity(Nachricht entity) {
    resetModel(); // DynaForm-Model zurücksetzen, damit die aktuelle Entität verwendte wird...
    if (entity == null) {
      conversationStore.setEntityPK(null);
    } else {
      conversationStore.setEntityPK(entity.getPk());
    }
  }

  public boolean isEntitySet() {
    return conversationStore.getEntityPK() != null;
  }

  @Redirect
  @UseCaseSecure(UseCasePermission.NACHRICHT_DELETE)
  @Override
  public String delete() {
    return delete(getEntity());
  }

  protected String delete(Nachricht entity) {
    edit.delete(entity);

    addMessageDeleteSuccess();

    resetStateAfterAction();
    return getParentViewId(); // definierter Parent, benutze deleteAndGoBack um zum vorherigen View zurückzukehren
  }



  @Redirect
  @UseCaseSecure(UseCasePermission.NACHRICHT_DELETE)
  public String deleteAndGoBack() {
    delete();
    return goBack(getParentViewId());
  }

  protected void addMessageDeleteSuccess() {
    addInfoMessage("entity.edit.action.delete.success.message", entityMeta.getEinzahlMessage());
  }

  public boolean isBtnDeleteRendered() {
    return hasPermission(UseCasePermission.NACHRICHT_DELETE);
  }

  @Redirect
  @Override
  public String cancel() {
    resetStateAfterAction();

    return goBack(getParentViewId());
  }

  @Override
  public boolean isBtnCancelRendered() {
    return true;
  }

  @Redirect
  @UseCaseSecure(UseCasePermission.NACHRICHT_EDIT)
  @Override
  public String save() {
    Nachricht entity = getEntity();

    callSave(entity);

    addMessageSaveSuccess(entity);

    resetStateAfterAction();

    return goBack(getParentViewId());
  }

  protected void callSave(Nachricht entity) {
    edit.save(entity);
  }

  @Redirect
  @Override
  public String reset() {
    super.reset();
    Nachricht entity = getEntity();
    resetStateAfterAction();
    setEntity(entity);
    return getViewId();
  }

  protected void addMessageSaveSuccess(Nachricht entity) {
    addInfoMessage("entity.edit.action.save.success.message", entityMeta.getEinzahlMessage());
  }

  @Override
  protected boolean isSavePermissionVorhanden() {
    return hasPermission(UseCasePermission.NACHRICHT_EDIT);
  }
  
  @Redirect
  public String edit(Nachricht entity) {
    conversationStore.setEntityPK(entity.getPk());
    return getViewId();
  }

  protected String getViewId() {
    return VIEW_ID;
  }

  protected String getParentViewId() {
    return PARENT_VIEW_ID;
  }

  protected void resetStateAfterAction() {
    conversationStore.close();
  }

  @de.ivu.elect.jee.faces.PreConditionCheck
  public void checkDoppelteBearbeitung() {
     entityViewStore.setEntity(getEntity());
  }

  @org.apache.deltaspike.core.api.scope.ViewAccessScoped
  public static class NachrichtEditViewScopeStore extends  de.ivu.elect.presentation.edit.AbstractViewScopeStore<Nachricht,   de.ivu.elect.business.benutzerverwaltung.entity.NachrichtPK  > {

    private static final long serialVersionUID = 1L;
  }
}
